require 'fastlane/action'
require 'spaceship'
require_relative '../helper/update_app_name_helper'

module Fastlane
  module Actions
    class UpdateAppNameAction < Action
      def self.run(params)
        user_name = params[:user_name]
        password = params[:password]
        app_id = params[:app_id]
        app_name = params[:app_name]

        client = Spaceship::Portal.login(user_name, password)
        client.select_team()
        apps = client.apps();
        for i in apps
          if i['identifier'] != app_id
            next
          else
            data = client.update_app_name!(i['appIdId'], app_name, mac: false)
            UI.message(data)
            UI.message("success")
          end
        end
        UI.message("The update_app_name plugin is working!")
      end

      def self.description
        "update app name"
      end

      def self.authors
        ["huyanping"]
      end

      def self.return_value
        # If your method provides a return value, you can describe here what it does
      end

      def self.details
        # Optional:
        ""
      end

      def self.available_options
        [
            FastlaneCore::ConfigItem.new(key: :user_name,
                                         env_name: "FASTLANE_USER",
                                         description: "user_name",
                                         optional: false,
                                         type: String),
            FastlaneCore::ConfigItem.new(key: :password,
                                         env_name: "FASTLANE_PASSWORD",
                                         description: "password",
                                         optional: false,
                                         type: String),
            FastlaneCore::ConfigItem.new(key: :app_id,
                                         env_name: "UPDATE_DEVICE_APP_ID",
                                         description: "app_id",
                                         optional: false,
                                         type: String),
            FastlaneCore::ConfigItem.new(key: :app_name,
                                         env_name: "UPDATE_DEVICE_APP_NAME",
                                         description: "app_name",
                                         optional: false,
                                         type: String)
        ]
      end

      def self.is_supported?(platform)
        # Adjust this if your plugin only works for a particular platform (iOS vs. Android, for example)
        # See: https://docs.fastlane.tools/advanced/#control-configuration-by-lane-and-by-platform
        #
        # [:ios, :mac, :android].include?(platform)
        true
      end
    end
  end
end
